#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define LIMITE 4

int temporizzatore=0;

typedef struct
{
    char p[4];
    char a[4];
} Tratta;

//FUNZIONE DI UTILITA' PER STABILIRE SE UN ARRAY DI STRINGHE CONTIENE UNA STRINGA
int contiene(char* codice, char* visitati[], int nVisitati){
    int i=0;
    for (i = 0; i < nVisitati; i++) {
        if(strcmp(codice,visitati[i]) == 0){            
            return 1;
        }
    }
    return 0;
}



int cerca(char* da, char* a,Tratta* tratte, int nTratte, char* visitati[], int nVisitati){
    int i=0;

    //PRIMA SOLUZIONE 'BANALE' DELLA RICORSIONE
    if(nVisitati>=LIMITE+2){        
        return 0;
    }

    //SECONDA SOLUZIONE 'BANALE' DELLA RICORSIONE
    for (i = 0; i < nTratte; i++) {
        if(strcmp(da,tratte[i].p) == 0&& strcmp(a,tratte[i].a)==0 ){
            printf("\n %s-%s ",da,a);
            return 1;
        }
    }
    
    
    //SE NON SIAMO IN UN CASO 'BANALE' DOBBIAMO RIDURRE IL PROBLEMA
    for (i = 0; i < nTratte; i++) {
        if(strcmp(a,tratte[i].a) == 0){
            if(!contiene(tratte[i].p,visitati,nVisitati)){
                visitati[nVisitati] = tratte[i].p;
                if(cerca(da,tratte[i].p,tratte,nTratte,visitati,nVisitati+1))
                {
                    //SE SIAMO QUI LE TRATTE DA da A tratte[i].p SONO GIA' STATE STAMPATE
                    printf(" -> %s-%s ",tratte[i].p,a);
                    return 1;
                }
            }
        }
    }
    
    return 0;
}


void cercatutti(char* da, char* a,Tratta* tratte, int nTratte, char* visitati[], int nVisitati,int* trovati,int nTrovati){
    int i=0;    
    
    //PRIMA SOLUZIONE 'BANALE' DELLA RICORSIONE    
    if(nVisitati>=LIMITE+2){        
        return;
    }
    
    //SECONDA SOLUZIONE 'BANALE' DELLA RICORSIONE
    for (i = 0; i < nTratte; i++) {
        if(strcmp(da,tratte[i].p) == 0&& strcmp(a,tratte[i].a)==0 ){
            
            //L'INTERA SOLUZIONE VIENE PRODOTTA ALL'ULTIMO PASSO DELLA RICORSIONE
            
            //LA TRATTA TROVATA QUI E' LA PRIMA
            printf("%s-%s ",da,a);
            
            //TUTTE LE ALTRE FINO ALLA DESTINAZIONE SONO NELL'ARRAY trovati IN ORDINE INVERSO
            for(i=nTrovati-1;i>=0;i--){
                printf("-> %s-%s ",tratte[trovati[i]].p,tratte[trovati[i]].a);
            }
            printf("\n");
            return;
        }
    }
    
    //SE NON SIAMO IN UN CASO 'BANALE' DOBBIAMO RIDURRE IL PROBLEMA
    for (i = 0; i < nTratte; i++) {
        if(strcmp(a,tratte[i].a) == 0){
            if(!contiene(tratte[i].p,visitati,nVisitati)){
                visitati[nVisitati] = tratte[i].p;
                trovati[nTrovati] = i; //NEL VETTORE trovati STIAMO ACCUMULANDO I RISULTATI PARZIALI
                
                //SARA' LA CHIAMATA RICORSIVA A PRODURRE L'INTERO RISULTATO
                cercatutti(da,tratte[i].p,tratte,nTratte,visitati,nVisitati+1,trovati,nTrovati+1);
            }
        }
    }    
}


int main(int argc, char** argv)
{
    FILE* fp;
    int nTratte = 0,virgole = 0,i=0;
    char c;    
    Tratta* tratte,temp;
    
    char* visitati[LIMITE+2];//VISITEREMO TUTTI GLI AEROPORTI INTERMEDI + I 2 DI PARTENZA E ARRIVO
    
    int trovati[LIMITE];//DA USARE NELLA cercatutti
    
    if ((fp = fopen("../routes.txt", "r")) != NULL) {
        
        //CONTIAMO LE RIGHE PER DIMENSIONARE CORRETTAMENTE IL VETTORE DELLE TRATTE
        while (fscanf(fp, "%c", &c) == 1) {
            if (c == '\n') {
                nTratte++;
            }
        }
        
        nTratte++; //L'ULTIMA RIGA NON CONTIENE UN \n
        
        rewind(fp);
        tratte = (Tratta*)malloc(nTratte * sizeof(Tratta));
        
        for (i = 0; i < nTratte; i++) {
            
            //CONSUMIAMO CARATTERI FINO ALLA SECONDA VIRGOLA
            virgole=0;
            do {
                fscanf(fp, "%c", &c);
                if (c == ',')
                    virgole++;
            } while (virgole < 2);
            
            //I SUCCESSIVI 3 CARATTERI SONO IL CODICE DELL'AEROPORTO DI PARTENZA
            fscanf(fp,"%c%c%c", &temp.p[0], &temp.p[1], &temp.p[2]);
            temp.p[3]='\0'; //RICORDIAMO SEMPRE IL TERMINATORE QUANDO COSTRUIAMO UNA STRINGA CARATTERE PER CARATTERE
            
            //CONSUMIAMO ULTERIORI CARATTERI FINO ALLA QUARTA VIRGOLA
            virgole=0;
            do {
                fscanf(fp, "%c", &c);
                if (c == ',')
                    virgole++;
            } while (virgole < 2);
            
            //I SUCCESSIVI 3 CARATTERI SONO IL CODICE DELL'AEROPORTO DI ARRIVO
            fscanf(fp,"%c%c%c", &temp.a[0], &temp.a[1], &temp.a[2]);
            temp.a[3]='\0'; //RICORDIAMO SEMPRE IL TERMINATORE QUANDO COSTRUIAMO UNA STRINGA CARATTERE PER CARATTERE
            
            tratte[i] = temp;            
            
            //CONSUMIAMO IL RESTO DELLA RIGA
            while (fscanf(fp, "%c", &c) == 1 && c != '\n') {
                // CONSUMO
            }
        }
    }
    
    printf("inserisci i codici degli aeroporti (es. PSR ATH):\n");
    scanf("%s%s",temp.p,temp.a);
    
    visitati[0]=temp.p;
    visitati[1]=temp.a;
    
    printf("Cerco una soluzione");
    cerca(temp.p,temp.a,tratte,nTratte,visitati,2);
    
    printf("Cerco tutte le soluzioni");
    cercatutti(temp.p,temp.a,tratte,nTratte,visitati,2,trovati,0);
    return 0;
}
 